/*  Somatic - A soma puzzle solver.
 *  Copyright (C) 2003 Marc Moerig
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef soma_fox_piecewin
#define soma_fox_piecewin

#define HAVE_OPENGL

#include <fx.h>
#include <fx3d.h>

#include "s_problem.hpp"
#include "sGFX_pieces.hpp"

//**************************************************************************

/** Just a small simple class to display program information. */
class FXAPI SomaPieceWin : public FXDialogBox {
  FXDECLARE(SomaPieceWin)
private:
  SomaPieceWin(){}
  
  FXGLVisual *glvisual;
  FXGLCanvas *glcanvas;
  SomaPiecesGFX *p_gfx;
  
  void drawScene();
  
public:

  enum{
    ID_GLCANVAS=FXDialogBox::ID_LAST,
    ID_LAST
  };
    
  /** constructor */
  SomaPieceWin(FXWindow* owner,const SomaProb *const p,FXGLCanvas *const other);
  
  long onExpose(FXObject*,FXSelector,void*);
  long onConfigure(FXObject*,FXSelector,void*);
  long onMouseClick(FXObject*,FXSelector,void*);
  long onMouseMove(FXObject*,FXSelector,void*);
  long onMouseWheel(FXObject*,FXSelector,void*);

  void create();
  
  /** destructor */
  virtual ~SomaPieceWin();
};

//**************************************************************************

#endif
