/*  Somatic - A soma puzzle solver.
 *  Copyright (C) 2003 Marc Moerig
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "s_vector.hpp"

//**************************************************************************

template<class T>
void SomaVector<T>::write(std::ostream& strm)const{
  strm << " (";
  strm.width(3);
  strm << x << ",";
  strm.width(3);
  strm << y << ",";
  strm.width(3);
  strm << z << ")";
}

//**************************************************************************

template<class T>
bool SomaVector<T>::read(std::istream& strm){
  char S;
  S=' '; 
  
  strm >> S;
  
  if(S!='('){ 
    std::cerr << "Error in SomaVector<T>::read(). '(' expected." << std::endl;
    return false;
  }else{
    strm >> x;
  }
  
  S=' '; 
  strm >> S;
  
  if(S==','){
    strm >> y;
  }else{
    std::cerr << "Error in SomaVector<T>::read(). ',' expected." << std::endl;
    return false;
  }
  
  S=' '; 
  strm >> S;
  
  if(S==','){
    strm >> z;
  }else  { 
    std::cerr << "Error in SomaVector<T>::read(). ',' expected." << std::endl;
    return false;
  }
  
  S=' '; 
  strm >> S;
  
  
  if(S==')'){
    return true;
  }else{
    std::cerr << "Error in SomaVector<T>::read(). ')' expected." << std::endl;
    return false;
  }
  
  
}

//**************************************************************************

template class SomaVector<int>;
template class SomaVector<double>;

//**************************************************************************

